wayland::server::xdg_surface_t(3)

NAME
wayland::server::xdg_surface_t - desktop user interface surface base interface

SYNOPSIS

#include <wayland-server-protocol-extra.hpp>

Inherits wayland::server::resource_t.

  Public Member Functions

std::function< void()> & on_destroy ()
destroy the xdg_surface
std::function< void(xdg_toplevel_t)> & on_get_toplevel ()
assign the xdg_toplevel surface role
std::function< void(xdg_popup_t, xdg_surface_t, xdg_positioner_t)> & on_get_popup ()
assign the xdg_popup surface role
std::function< void(int32_t, int32_t, int32_t, int32_t)> & on_set_window_geometry ()
set the new window geometry
std::function< void(uint32_t)> & on_ack_configure ()
ack a configure event
void configure (uint32_t serial, bool post=true)
suggest a surface change
void post_not_constructed (std::string const &msg)
Post error:
void post_already_constructed (std::string const &msg)
Post error:
void post_unconfigured_buffer (std::string const &msg)
Post error:
bool proxy_has_object () const
Check whether this wrapper actually wraps an object.
void post_no_memory () const
uint32_t get_id () const
client_t get_client () const
unsigned int get_version () const
std::string get_class ()

  Static Public Attributes

static constexpr std::uint32_t configure_since_version = 1
Minimum protocol version required for the configure function.

Detailed Description

desktop user interface surface base interface

An interface that may be implemented by a wl_surface, for implementations that provide a desktop-style user interface.

It provides a base set of functionality required to construct user interface elements requiring management by the compositor, such as toplevel windows, menus, etc. The types of functionality are split into xdg_surface roles.

Creating an xdg_surface does not set the role for a wl_surface. In order to map an xdg_surface, the client must create a role-specific object using, e.g., get_toplevel, get_popup. The wl_surface for any given xdg_surface can have at most one role, and may not be assigned any role not based on xdg_surface.

A role must be assigned before any other requests are made to the xdg_surface object.

The client must call wl_surface.commit on the corresponding wl_surface for the xdg_surface state to take effect.

Creating an xdg_surface from a wl_surface which has a buffer attached or committed is a client error, and any attempts by a client to attach or manipulate a buffer prior to the first xdg_surface.configure call must also be treated as errors.

After creating a role-specific object and setting it up, the client must perform an initial commit without any buffer attached. The compositor will reply with an xdg_surface.configure event. The client must acknowledge it and is then allowed to attach a buffer to map the surface.

Mapping an xdg_surface-based role surface is defined as making it possible for the surface to be shown by the compositor. Note that a mapped surface is not guaranteed to be visible once it is mapped.

For an xdg_surface to be mapped by the compositor, the following conditions must be met: (1) the client has assigned an xdg_surface-based role to the surface (2) the client has set and committed the xdg_surface state and the role-dependent state to the surface (3) the client has committed a buffer to the surface

A newly-unmapped surface is considered to have met condition (1) out of the 3 required conditions for mapping a surface if its role surface has not been destroyed, i.e. the client must perform the initial commit again before attaching a buffer.

Definition at line 1094 of file wayland-server-protocol-extra.hpp.

Member Function Documentation

  void xdg_surface_t::configure (uint32_t serial, bool post = true)

suggest a surface change

Parameters
    serial serial of the configure event

The configure event marks the end of a configure sequence. A configure sequence is a set of one or more events configuring the state of the xdg_surface, including the final xdg_surface.configure event.

Where applicable, xdg_surface surface roles will during a configure sequence extend this event as a latched state sent as events before the xdg_surface.configure event. Such events should be considered to make up a set of atomically applied configuration states, where the xdg_surface.configure commits the accumulated state.

Clients should arrange their surface for the new states, and then send an ack_configure request with the serial sent in this configure event at some point before committing the new surface.

If the client receives multiple configure events before it can respond to one, it is free to discard all but the last event it received.

Definition at line 1188 of file wayland-server-protocol-extra.cpp.

  std::string wayland::server::resource_t::get_class () [inherited]
Retrieve the interface name (class) of a resource object.

Returns
    Interface name of the resource object.

  client_t wayland::server::resource_t::get_client () const [inherited]
Get the associated client

Returns
    the client that owns the resource.

  uint32_t wayland::server::resource_t::get_id () const [inherited]
Get the internal ID of the resource

Returns
    the internal ID of the resource

  unsigned int wayland::server::resource_t::get_version () const [inherited]
Get interface version

Returns
    Interface version this resource has been constructed with.

  std::function< void(uint32_t)> & xdg_surface_t::on_ack_configure ()

ack a configure event

Parameters
    serial the serial from the configure event

When a configure event is received, if a client commits the surface in response to the configure event, then the client must make an ack_configure request sometime before the commit request, passing along the serial of the configure event.

For instance, for toplevel surfaces the compositor might use this information to move a surface to the top left only when the client has drawn itself for the maximized or fullscreen state.

If the client receives multiple configure events before it can respond to one, it only has to ack the last configure event.

A client is not required to commit immediately after sending an ack_configure request - it may even ack_configure several times before its next surface commit.

A client may send multiple ack_configure requests before committing, but only the last request sent before a commit indicates which configure event the client really is responding to.

Definition at line 1182 of file wayland-server-protocol-extra.cpp.

  std::function< void()> & xdg_surface_t::on_destroy ()

destroy the xdg_surface Destroy the xdg_surface object. An xdg_surface must only be destroyed after its role object has been destroyed.

Definition at line 1158 of file wayland-server-protocol-extra.cpp.

  std::function< void(xdg_popup_t, xdg_surface_t, xdg_positioner_t)> & xdg_surface_t::on_get_popup ()

assign the xdg_popup surface role

Parameters
    id
    parent
    positioner

This creates an xdg_popup object for the given xdg_surface and gives the associated wl_surface the xdg_popup role.

If null is passed as a parent, a parent surface must be specified using some other protocol, before committing the initial state.

See the documentation of xdg_popup for more details about what an xdg_popup is and how it is used.

Definition at line 1170 of file wayland-server-protocol-extra.cpp.

  std::function< void(xdg_toplevel_t)> & xdg_surface_t::on_get_toplevel ()

assign the xdg_toplevel surface role

Parameters
    id

This creates an xdg_toplevel object for the given xdg_surface and gives the associated wl_surface the xdg_toplevel role.

See the documentation of xdg_toplevel for more details about what an xdg_toplevel is and how it is used.

Definition at line 1164 of file wayland-server-protocol-extra.cpp.

  std::function< void(int32_t, int32_t, int32_t, int32_t)> & xdg_surface_t::on_set_window_geometry ()

set the new window geometry

Parameters
    x
    y
    width
    height

The window geometry of a surface is its 'visible bounds' from the user's perspective. Client-side decorations often have invisible portions like drop-shadows which should be ignored for the purposes of aligning, placing and constraining windows.

The window geometry is double buffered, and will be applied at the time wl_surface.commit of the corresponding wl_surface is called.

When maintaining a position, the compositor should treat the (x, y) coordinate of the window geometry as the top left corner of the window. A client changing the (x, y) window geometry coordinate should in general not alter the position of the window.

Once the window geometry of the surface is set, it is not possible to unset it, and it will remain the same until set_window_geometry is called again, even if a new subsurface or buffer is attached.

If never set, the value is the full bounds of the surface, including any subsurfaces. This updates dynamically on every commit. This unset is meant for extremely simple clients.

The arguments are given in the surface-local coordinate space of the wl_surface associated with this xdg_surface.

The width and height must be greater than zero. Setting an invalid size will raise an error. When applied, the effective window geometry will be the set window geometry clamped to the bounding rectangle of the combined geometry of the surface of the xdg_surface and the associated subsurfaces.

Definition at line 1176 of file wayland-server-protocol-extra.cpp.

  void xdg_surface_t::post_already_constructed (std::string const & msg)

Post error:

Definition at line 1198 of file wayland-server-protocol-extra.cpp.

  void wayland::server::resource_t::post_no_memory () const [inherited]
Post 'not enough memory' error to the client

If the compositor has not enough memory to fulfill a certail request of the client, this function can be called to notify the client of this circumstance.

  void xdg_surface_t::post_not_constructed (std::string const & msg)

Post error:

Definition at line 1193 of file wayland-server-protocol-extra.cpp.

  void xdg_surface_t::post_unconfigured_buffer (std::string const & msg)

Post error:

Definition at line 1203 of file wayland-server-protocol-extra.cpp.

  bool wayland::server::resource_t::proxy_has_object () const [inherited]

Check whether this wrapper actually wraps an object.

Returns
    true if there is an underlying object, false if this wrapper is empty

Member Data Documentation

  constexpr std::uint32_t wayland::server::xdg_surface_t::configure_since_version = 1 [static], [constexpr]

Minimum protocol version required for the configure function.

Definition at line 1251 of file wayland-server-protocol-extra.hpp.

Author

Generated automatically by Doxygen for Wayland++ from the source code.